"""
    probleme.py
"""

import importlib
import hashlib
import json

class Probleme:
    def __init__(self, dico):
        if "CRYPTO" in dico:
            self.crypto = dico["CRYPTO"]
        if "PLAIN" in dico:
            self.plain = dico["PLAIN"]
        if "METHOD" in dico:
            self.method = dico["METHOD"]
        if "KEY_TYPE" in dico:
            self.type_cle = dico["KEY_TYPE"]
        if "KEY" in dico:
            self.cle = dico["KEY"]
        if ("PLAIN" in dico) and ("CRYPTO" not in dico):
            METHOD = importlib.import_module("METHODS." + dico["METHOD"])

            CLE = importlib.import_module("KEYS." + dico["KEY_TYPE"])
            keyword = ""
            if "KEYWORD" in dico:
                keyword = dico["KEYWORD"]
            cle = CLE.gene_key(keyword)
            if "KEY" not in dico:
                dico["KEY"] = cle
                self.cle = cle
            self.crypto = METHOD.chiffrer(dico["PLAIN"], cle)
            dico["CRYPTO"] = self.crypto

            if "CRYPTO" in dico:
                md5sum = hashlib.md5((self.crypto).encode('utf-8')).hexdigest()
                json.dump(dico, open("./CRYPTOS/WORK/" + md5sum + ".cry","w"))
            else:
                raise Exception            
                